
#include "stm32f10x.h"
#include "WG12864B.h"


 uint32_t i;  //    
 uint16_t j;  //   
 uint16_t k;  //   

//  
  NVIC_InitTypeDef NVIC_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	GPIO_InitTypeDef GPIO_InitStructure;
	ADC_InitTypeDef ADC_InitStructure;








void ADC1_Init(void)
{
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);// GPIOC 
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);//   GPIO
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);// ADC1
	RCC_ADCCLKConfig(RCC_PCLK2_Div8);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
	GPIO_Init(GPIOC, &GPIO_InitStructure);



	ADC_InitStructure.ADC_Mode = ADC_Mode_Independent; //Configures the ADC to operate in independent
	ADC_InitStructure.ADC_ScanConvMode = DISABLE; //Specifies whether the conversion is performed in Single (one channel) mode
	ADC_InitStructure.ADC_ContinuousConvMode = ENABLE; //Specifies whether the conversion is performed in Continuous mode 
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;
	ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right; //Specifies whether the ADC data alignment is left or right
	ADC_InitStructure.ADC_NbrOfChannel = 1; //Specifies the number of ADC channels that will be converted using the sequencer for regular channel group
	ADC_Init(ADC1, &ADC_InitStructure);

	ADC_RegularChannelConfig(ADC1, ADC_Channel_10, 1, ADC_SampleTime_239Cycles5); //Configures for the selected ADC regular channel

	ADC_Cmd(ADC1, ENABLE);												//  ADC1
 /* Enable ADC1 reset calibration register */   
  ADC_ResetCalibration(ADC1);
  /* Check the end of ADC1 reset calibration register */
  while(ADC_GetResetCalibrationStatus(ADC1));

  /* Start ADC1 calibration */
  ADC_StartCalibration(ADC1);
  /* Check the end of ADC1 calibration */
  while(ADC_GetCalibrationStatus(ADC1));

	ADC_SoftwareStartConvCmd(ADC1, ENABLE); //Enables the selected ADC software start conversion
	ADC_ITConfig(ADC1, ADC_IT_EOC, ENABLE); //Enables the specified ADC interrupts

}



void USART1_Init(void)
{
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);// GPIO 
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);//   GPIO
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);// USART1

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_OD;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

 /* USARTx configured as follow:
        - BaudRate = 115200 baud  
        - Word Length = 8 Bits
        - One Stop Bit
        - No parity
        - Hardware flow control disabled (RTS and CTS signals)
        - Receive and transmit enabled
  */
  USART_InitStructure.USART_BaudRate = 9600;//C  9600 
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;//8  
  USART_InitStructure.USART_StopBits = USART_StopBits_1;// -: 1
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;// /

	USART_Init(USART1, &USART_InitStructure);
	USART_Cmd(USART1, ENABLE);												//  USART1

}


/**
  * @brief  Configures NVIC and Vector Table base location.
  * @param  None
  * @retval None
  */
void NVIC_Configuration(void)
{

    /* Configure and enable ADC interrupt */
#if defined (STM32F10X_LD_VL) || defined (STM32F10X_MD_VL) || defined (STM32F10X_HD_VL)
  NVIC_InitStructure.NVIC_IRQChannel = ADC1_IRQn;
#else
  NVIC_InitStructure.NVIC_IRQChannel = ADC1_2_IRQn;
#endif
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
}











int main (void)
{
//	CDelay 1000
    for(i=0; i<0xFFF; i++);
	
//NVIC_Configuration();
	USART1_Init();
//	ADC1_Init();
//LCD_Init();


//  
  RCC->APB2ENR |= RCC_APB2ENR_IOPBEN; //  
  GPIOB->CRL |= GPIO_CRL_MODE0_0;     // PB0     
  GPIOB->CRL &= ~GPIO_CRL_CNF0;       // Push-Pull   PB0  

  GPIOB->CRL |= GPIO_CRL_MODE1_0;     // PB1     
  GPIOB->CRL &= ~GPIO_CRL_CNF1;       // Push-Pull   PB1  

  GPIOB->CRL |= GPIO_CRL_MODE2_0;     // PB2     
  GPIOB->CRL &= ~GPIO_CRL_CNF2;       // Push-Pull   PB2  

  GPIOB->CRL |= GPIO_CRL_MODE5_0;     // PB5     
  GPIOB->CRL &= ~GPIO_CRL_CNF5;       // Push-Pull   PB5  

  GPIOB->CRL |= GPIO_CRL_MODE7_0;     // PB6     
  GPIOB->CRL &= ~GPIO_CRL_CNF7;       // Push-Pull   PB6  




  while(1)
{
USART_SendData(USART1, 0xAA);
    for(i=0; i<0xFFFF; i++);      //
USART_SendData(USART1, 0xBB);
    for(i=0; i<0xFFFF; i++);      //
USART_SendData(USART1, 0xCC);
    for(i=0; i<0xFFFF; i++);      //
USART_SendData(USART1, 0xDD);


    GPIOB->BSRR |= GPIO_BSRR_BS0;     //  "1" PB0,  
    for(i=0; i<0x0003FFFF; i++);      //
    GPIOB->BSRR |= GPIO_BSRR_BS1;     //  "1" PB1,  
    for(i=0; i<0x0003FFFF; i++);      //
    GPIOB->BSRR |= GPIO_BSRR_BS2;     //  "1" PB2,  
    for(i=0; i<0x0003FFFF; i++);      //
    GPIOB->BSRR |= GPIO_BSRR_BS5;     //  "1" PB5,  
    for(i=0; i<0x0003FFFF; i++);      //
    GPIOB->BSRR |= GPIO_BSRR_BS7;     //  "1" PB6,  
    for(i=0; i<0x0003FFFF; i++);      //


    GPIOB->BSRR |= GPIO_BSRR_BR0;     //  "0" PB0,  
    GPIOB->BSRR |= GPIO_BSRR_BR1;     //  "0" PB1,  
    GPIOB->BSRR |= GPIO_BSRR_BR2;     //  "0" PB2,  
    GPIOB->BSRR |= GPIO_BSRR_BR5;     //  "0" PB5,  
    GPIOB->BSRR |= GPIO_BSRR_BR7;     //  "0" PB6,  
    for(i=0; i<0x0003FFFF; i++);      //
    for(i=0; i<0x0003FFFF; i++);      //
    for(i=0; i<0x0003FFFF; i++);      //
}

}




void ADC1_2_IRQHandler(void)
{
int temp;
int tempH;
int tempL;

temp = ADC_GetConversionValue(ADC1);
tempL=temp;
tempH=temp>>8;
USART_SendData(USART1, 0x00);
for(i=0; i<0x00000FFF; i++);      //
USART_SendData(USART1, tempH);
for(i=0; i<0x00000FFF; i++);      //
USART_SendData(USART1, tempL);
for(i=0; i<0x00000FFF; i++);      //
}


